/**
 * Sample React Native App
 * https://github.com/facebook/react-native
 *
 * @format
 * @flow
 */

import React, {Component} from 'react';
import {StyleSheet, Text, SafeAreaView} from 'react-native';
import JMessage from "jmessage-react-plugin";
import JPushModule from "jpush-react-native";


type Props = {};
export default class App extends Component<Props> {
    /**
     * 构造函数
     * @param props
     */
    constructor(props) {
        super(props);
    }

    componentDidMount() {
        JPushModule.init();
        JPushModule.setLoggerEnable(true);
        console.log("DemoAppLog===JPushModule.init")

        JPushModule.getRegistrationID((registrationId) => {
            console.log("DemoAppLog===registerID===="+registrationId.registerID)
        });

        JMessage.init({
            appkey: "e170af5aa5fb2ea6bc243957",
            isOpenMessageRoaming: true,// 是否开启消息漫游，默认不开启
            isProduction: true, // 是否为生产模式
        });
        JMessage.setDebugMode({enable: true});
        console.log("DemoAppLog===JMessage.init")

        JMessage.addSyncOfflineMessageListener((result) => {
            console.log("DemoAppLog===addSyncOfflineMessageListener====" + JSON.stringify(result))
            JMessage.getConversations((result) => {
                console.log("DemoAppLog===addSyncOfflineMessageListener==JMessage.getConversations==" + JSON.stringify(result))
            }, (error) => {
                console.log("DemoAppLog===addSyncOfflineMessageListener==JMessage.getConversations==error===" + JSON.stringify(error))
            });
        });

        JMessage.addSyncRoamingMessageListener((result) => {
            console.log("DemoAppLog===addSyncRoamingMessageListener====" + JSON.stringify(result))
        });

        JPushModule.addConnectEventListener((result) => {
            console.log("DemoAppLog===addConnectEventListener===" + JSON.stringify(result))
            JMessage.getMyInfo((UserInf) => {
                if (UserInf.username === undefined) {
                    // 未登录
                    console.log("DemoAppLog===addConnectEventListener===getMyInfo===未登录")
                } else {
                    // 已登录
                    console.log("DemoAppLog===addConnectEventListener===getMyInfo===已登录")
                }
            })
            JMessage.login({
                username: '18006127325',
                password: '123456'
            }, () => {/*登录成功回调*/
                console.log("DemoAppLog===addConnectEventListener===登录成功===")
                const timeoutId = setTimeout(() => {
                    JMessage.getConversations((result) => {
                        console.log("DemoAppLog===addConnectEventListener===getConversations===result===" + JSON.stringify(result))
                    }, (error) => {
                        console.log("DemoAppLog===addConnectEventListener===getConversations===error===" + JSON.stringify(error))
                    });
                    clearTimeout(timeoutId)
                }, 3000);
            }, (error) => {
                console.log("DemoAppLog===addConnectEventListener===登录失败===")
            });
        });

        JMessage.addReceiveMessageListener((message) => {
            console.log("DemoAppLog===addReceiveMessageListener" + JSON.stringify(message))
        });
    }

    render() {
        return (
                <SafeAreaView style={styles.container}>
                    <Text>测试</Text>
                </SafeAreaView>
        );
    }
}

const styles = StyleSheet.create({
    container: {
        flex: 1,
        justifyContent: 'center',
        alignItems: 'center',
        backgroundColor: '#F5FCFF',
    },
});
